from statement import *
from typing import *
from syntax import *

class program(compound):

    fields = [
#        'rules',
#        'invariants',
        'block',
        ]

    format = '<program>'

    def write(self, out):
        for s in self.block:
            s.write(out, "")

    # This finds all the replace statements at the top level of
    # the program, removes them, and replaces them.
    def strip_replacements(self):
        block = []
        replacements = []

        for s in self.block:
            if isinstance(s, replace_stmt):
                replacements.append(s)
            else:
                block.append(s)

        self.block = block

        return replacements

    def rts(self):

        tymap = typemap()
        self.tymap = tymap
        self.walk(None, 'find_type', tymap)

        if False:
            for i in tymap:
                print i + ": " + ", ".join([str(j) for j in tymap[i]])

            print "---> <---"

        # Special variables. These are assumed to never be assigned,
        # and they never cause things to be merged.
        specials = {
            'undef': [],
            'True': [],
            'False': [],
            }

        for i in specials:
            if i in tymap:
                del tymap[i]
                               
        leaders, self.merged = tymap.merge_types(specials)

        self.walk(None, 'assign_merged_types', self)

        if False:

            print "---> Variable Bases <---"
            
            for l in leaders:
                print ", ".join(self.merged[l]) + ":"

                for t in tymap[l]:
                    print "   ", t

#         print "---> Finding Strength <---"


        # At this point, the only types that will be returned by find_all_types
        # are good types, which do not have a merged_with field. We can now do
        # structural equivlancing on types.

        types = self.find_all_types()

        for t0 in types:
            if t0.merged_with is not None:
                continue

            for t1 in types:

                if t0 is t1:
                    continue

                if t0.struct_equiv(t1):
                    t1.merged_with = t0

        # Assign the merged types (again).
        self.walk(None, 'assign_merged_types', self)

        # Now, find the bindings and the bases in the program. We calculate
        # the set of bound variables at each point in the program, and then
        # use this to compute how strong each set operation is. We also use
        # this to compute the set of sets that need the remove operation.
        
        self.bound = [ None ]
        self.bases = {}
        self.needs_remove = []

        # The set of sets that have been forced to be smaps.
        self.smaps = []

        self.bindings(self)

        del self.bound


#        for v, l in self.bases.iteritems():
#            print v, "\t", l

    def find_all_types(self):

        all_types = []

        def walker(o):
            if isinstance(o, list):
                for v in o:
                    walker(v)

            if isinstance(o, syntax):
                if hasattr(o, 'type'):
                    t = getattr(o, 'type')

                    if t:
                        for tt in t.gather_types():
                            if tt not in all_types:
                                all_types.append(tt)

                    for f in o.__class__.fields:
                        v = getattr(o, f)
                        walker(v)

        walker(self)

#        print "All Types", all_types
        return all_types
                

#     def walk_types(self, m, *args):
#         at = self.find_all_types()

#         self.tymap.walk_types(m, *args)

    

import os

if __name__ == "__main__":
    os.system("python main.py prpq.txt")
