#include "new_pyapts.h"

#include <stdio.h>
#include <unistd.h>
#include <malloc.h>
#include <time.h>

size_t memory_used = 0;
size_t memory_high = 0;

void *operator new(size_t size) {
    memory_used += size;
    if (memory_used > memory_high)
        memory_high = memory_used;

    int *ip = (int *) malloc(size + sizeof(int));
    ip[0] = size;

    return &(ip[1]);
}

void operator delete(void *data) {
    int *idata = (int *) data;
    idata -= 1;
    memory_used -= *idata;
    free(idata);
}

void show_profile(const char *label) {
    printf("# mem_%s %u\n", label, memory_high / 1024);
    printf("# mem_used_%s %u\n", label, memory_used / 1024);
    printf("# time_%s %.03f\n", label, clock() * 1.0 / CLOCKS_PER_SEC);
}
