#ifndef READING_H
#define READING_H

#include "data.h"

#include <vector>
#include <string>

using namespace std;

struct Reading : public Data {
    virtual void discriminate() { }

    virtual int leafdist() = 0;
    virtual Reading *replacement();
    Reading();
};

struct IntReading : Reading {
    int value;

    static IntReading *factory(int);
    
    IntReading(int);    
    void print();
    int leafdist();
};

struct TupleReading : Reading {
    vector<Reading *> contents;
    TupleReading *_replacement;
    
    TupleReading();
    void print();
    int leafdist();
    Reading *replacement();
};

struct StringReading : Reading {
    string value;

    static StringReading *factory(char *);
    
    StringReading(char *);
    void print();
    int leafdist();
};

struct FunctorReading : Reading {
    StringReading *name;
    TupleReading *tuple;
    Reading *_replacement;
    
    FunctorReading(StringReading *, TupleReading *);
    void print();
    int leafdist();
    Reading *replacement();
};

struct SetReading : Reading {
    vector<Reading *> contents;

    void print();
    int leafdist();
};

Reading **read_readings(int);

#endif
