#!/usr/bin/env bash

# This uses patton to build the different variants of a patton program.
#
# usage: run_patton.sh <patton file> <prefix> <additional c flags>

BASE="`dirname $0`"


SOURCE="$1"
PREFIX="$2"
shift 2
CXXFLAGS="-O2 -ggdb -I$BASE $*"

build () {
    echo Building "$PREFIX.$1"
    python "$BASE/main.py" "$SOURCE" "$PREFIX.$1.cc" $2 $3
    g++ -o "$PREFIX.$1" "$PREFIX.$1.cc" $BASE/pyapts.cc $BASE/reading.cc $CXXFLAGS
}

build based-na rts-na rts-na
build based-hashing rts-hashing rts-hashing
build uniform-na uniform-na uniform-na
build uniform-hashing uniform-hashing uniform-hashing
build mixed-na rts-na uniform-na
build mixed-hashing.cc  rts-hashing uniform-hashing

